#region Copyright Syncfusion Inc. 2001 - 2005
//
//  Copyright Syncfusion Inc. 2001 - 2005. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Any infringement will be prosecuted under
//  applicable laws. 
//
#endregion

using System;
using System.Diagnostics;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.IO;
using System.Data;
using System.Data.OleDb;
using System.Data.SqlClient;
using System.Xml;

using Syncfusion.Windows.Forms;
using Syncfusion.Drawing;
using Syncfusion.Windows.Forms.Grid;

// TODO: SHould also handle double click on resize line (covered cells behavior)
// TODO: ScrollTipFeedback
namespace GDBGMultiHeader
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
    {
		private System.Windows.Forms.Button expandAllbutton;
		private System.Windows.Forms.Button collapseAllButton;
		private System.Windows.Forms.Button okButton;
		private System.Windows.Forms.Panel panel1;
        private GridDataBoundGrid gridDataBoundGrid1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//Listen to the IBindingList.ListChanged events instead of the
			//CurrencyManager events.
			this.gridDataBoundGrid1.UseListChangedEvent = true;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.expandAllbutton = new System.Windows.Forms.Button();
            this.collapseAllButton = new System.Windows.Forms.Button();
            this.okButton = new System.Windows.Forms.Button();
            this.panel1 = new System.Windows.Forms.Panel();
            this.gridDataBoundGrid1 = new Syncfusion.Windows.Forms.Grid.GridDataBoundGrid();
            this.panel1.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).BeginInit();
            this.SuspendLayout();
            // 
            // expandAllbutton
            // 
            this.expandAllbutton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
            this.expandAllbutton.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.expandAllbutton.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.expandAllbutton.Location = new System.Drawing.Point(24, 306);
            this.expandAllbutton.Name = "expandAllbutton";
            this.expandAllbutton.Size = new System.Drawing.Size(104, 24);
            this.expandAllbutton.TabIndex = 1;
            this.expandAllbutton.Text = "Expand All";
            this.expandAllbutton.Click += new System.EventHandler(this.expandAllbutton_Click);
            // 
            // collapseAllButton
            // 
            this.collapseAllButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
            this.collapseAllButton.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.collapseAllButton.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.collapseAllButton.Location = new System.Drawing.Point(133, 306);
            this.collapseAllButton.Name = "collapseAllButton";
            this.collapseAllButton.Size = new System.Drawing.Size(96, 24);
            this.collapseAllButton.TabIndex = 1;
            this.collapseAllButton.Text = "Collapse All";
            this.collapseAllButton.Click += new System.EventHandler(this.collapseAllButton_Click);
            // 
            // okButton
            // 
            this.okButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
            this.okButton.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.okButton.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.okButton.Location = new System.Drawing.Point(629, 306);
            this.okButton.Name = "okButton";
            this.okButton.Size = new System.Drawing.Size(88, 24);
            this.okButton.TabIndex = 1;
            this.okButton.Text = "OK";
            this.okButton.Click += new System.EventHandler(this.okButton_Click);
            // 
            // panel1
            // 
            this.panel1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.panel1.Controls.Add(this.gridDataBoundGrid1);
            this.panel1.Controls.Add(this.okButton);
            this.panel1.Dock = System.Windows.Forms.DockStyle.Fill;
            this.panel1.Location = new System.Drawing.Point(0, 0);
            this.panel1.Name = "panel1";
            this.panel1.Size = new System.Drawing.Size(739, 342);
            this.panel1.TabIndex = 2;
            // 
            // gridDataBoundGrid1
            // 
            this.gridDataBoundGrid1.AllowDragSelectedCols = true;
            this.gridDataBoundGrid1.AlphaBlendSelectionColor = System.Drawing.Color.FromArgb(((int)(((byte)(64)))), ((int)(((byte)(255)))), ((int)(((byte)(215)))), ((int)(((byte)(0)))));
            this.gridDataBoundGrid1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
                        | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.gridDataBoundGrid1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.gridDataBoundGrid1.DefaultColWidth = 70;
            this.gridDataBoundGrid1.DefaultRowHeight = 18;
            this.gridDataBoundGrid1.HorizontalThumbTrack = true;
            this.gridDataBoundGrid1.ListBoxSelectionMode = System.Windows.Forms.SelectionMode.One;
            this.gridDataBoundGrid1.Location = new System.Drawing.Point(23, 11);
            this.gridDataBoundGrid1.Name = "gridDataBoundGrid1";
            this.gridDataBoundGrid1.ShowCurrentCellBorderBehavior = Syncfusion.Windows.Forms.Grid.GridShowCurrentCellBorder.GrayWhenLostFocus;
            this.gridDataBoundGrid1.Size = new System.Drawing.Size(694, 288);
            this.gridDataBoundGrid1.SmartSizeBox = false;
            this.gridDataBoundGrid1.SortBehavior = Syncfusion.Windows.Forms.Grid.GridSortBehavior.DoubleClick;
            this.gridDataBoundGrid1.TabIndex = 3;
            this.gridDataBoundGrid1.Text = "gridDataBoundGrid1";
            this.gridDataBoundGrid1.VerticalThumbTrack = true;
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(739, 342);
            this.Controls.Add(this.expandAllbutton);
            this.Controls.Add(this.collapseAllButton);
            this.Controls.Add(this.panel1);
            this.Name = "Form1";
            this.Text = "ExpandGrid...";
            this.Load += new System.EventHandler(this.Form1_Load);
            this.panel1.ResumeLayout(false);
            ((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).EndInit();
            this.ResumeLayout(false);

		}
		#endregion

        [STAThread]
        public static void Main()
        {
            Application.Run(new Form1());
        }

		Hashtable checkBoxValues = new Hashtable();
		Hashtable unboundValues = new Hashtable();
		GridModel gridModel = null;
		GridModelDataBinder gridBinder = null;

		void ReadXml(DataSet ds, string xmlFileName)
		{
			for (int n = 0; n < 10; n++)
			{
				if (File.Exists(xmlFileName))
				{
					ds.ReadXml(xmlFileName);
					break;
				}
				xmlFileName = @"..\" + xmlFileName;
			}
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			// cache grid model and binder
			this.gridModel = this.gridDataBoundGrid1.Model;
			this.gridBinder = this.gridDataBoundGrid1.Binder;

			// Reduce flicker
            this.gridDataBoundGrid1.BeginUpdate();

            DelayedStatusDialog progressDialog = new DelayedStatusDialog(gridModel);
            gridModel.OperationFeedbackListener = progressDialog;

			DataSet ds = new DataSet();

			// we'll read the data from a local XML file
			// set loadfromSqlServer if you want to access your SQLserver
			bool loadfromSqlServer = false;
			if (loadfromSqlServer)
			{
				SqlDataAdapter da = new SqlDataAdapter(
					"select * from Categories;select * from Products;select * from \"Order Details\";Select SupplierID, CompanyName, City, Region, Country from Suppliers",
					"data source=(local)\\NetSDK;initial catalog=Northwind;integrated security=SSPI");

				da.Fill(ds, "Categories");
			}
			else
				ReadXml(ds, @"\Expand.xml");

			ds.Tables[1].TableName = "Products";
			ds.Tables[2].TableName = "OrderDetails";
			ds.Tables[3].TableName = "Suppliers";

			ds.Relations.Add(
				ds.Tables[0].Columns["CategoryID"],
				ds.Tables[1].Columns["CategoryID"]);
			ds.Relations[0].RelationName = "Category_Products";

			ds.Relations.Add(
				ds.Tables[1].Columns["ProductID"],
				ds.Tables[2].Columns["ProductID"]);
			ds.Relations[1].RelationName = "Products_OrderDetails";

			this.gridDataBoundGrid1.DataMember = "Categories";
			this.gridDataBoundGrid1.DataSource = ds;

			GridHierarchyLevel hlCategory_Products = gridBinder.AddRelation("Category_Products");
			GridHierarchyLevel hlProducts_OrderDetails = gridBinder.AddRelation("Products_OrderDetails");
			// "-" indicates a covered cell
			// "." indicates a new row

			GridHierarchyLevel hlCategories = gridBinder.RootHierarchyLevel;
			hlCategories.LayoutColumns(
				new string[] {
								 "CategoryID", "CategoryName", "-", "Description", "-", "-", "-", "-"
							 });
			hlCategory_Products.LayoutColumns(
				new string[] {
								 "", "ProductID", "ProductName", "-", "-", "SupplierID", "-", "-", /*"CategoryID", */
								 ".", // show subsequent fields in a 2nd row
								 "",
								 "QuantityPerUnit",
								 "UnitPrice",
								 "UnitsInStock",
								 "UnitsOnOrder",
								 "ReorderLevel",
								 "Discontinued",
			});
			hlProducts_OrderDetails.LayoutColumns(
				new string[] {
								 "", "-", "OrderID", /*"ProductID", */"UnitPrice", "Quantity", "Discount"
							 });

			GridStyleInfo supplierIDStyle = hlCategory_Products.InternalColumns["SupplierID"].StyleInfo;
			supplierIDStyle.CellType = "GridListControl";
			supplierIDStyle.DataSource = ds.Tables["Suppliers"];
			supplierIDStyle.DisplayMember = "CompanyName";
			supplierIDStyle.ValueMember = "SupplierID";
			supplierIDStyle.HorizontalAlignment = GridHorizontalAlignment.Left;

			GridStyleInfo discontinuedStyle = hlCategory_Products.InternalColumns["Discontinued"].StyleInfo;
			discontinuedStyle.CellType = "CheckBox";
			discontinuedStyle.HorizontalAlignment = GridHorizontalAlignment.Center;


			this.gridDataBoundGrid1.HighlightCurrentColumnHeader = true;
			this.gridDataBoundGrid1.ShowTreeLines = true;

			// Copy over bound columns and add one unbound extra column at the end
			GridBoundColumnsCollection columns = (GridBoundColumnsCollection) this.gridBinder.InternalColumns.Clone();
			this.gridBinder.GridBoundColumns = columns;

			// Enable SelectAll mode for current cell (looks better)
			gridModel.Options.ShowCurrentCellBorderBehavior = GridShowCurrentCellBorder.WhenGridActive;
			gridModel.Options.ActivateCurrentCellBehavior = GridCellActivateAction.SelectAll;

			// Move current cell to top-left corner.
            this.gridDataBoundGrid1.CurrentCell.MoveTo(gridModel.Rows.HeaderCount + 1, gridModel.Cols.HeaderCount + 1);


            // Resize rows option
            gridModel.Options.ResizeRowsBehavior = GridResizeCellsBehavior.ResizeSingle | GridResizeCellsBehavior.OutlineBounds | GridResizeCellsBehavior.OutlineHeaders;
            gridModel.Options.ResizeColsBehavior = GridResizeCellsBehavior.ResizeSingle | GridResizeCellsBehavior.AllowDragOutside | GridResizeCellsBehavior.OutlineBounds | GridResizeCellsBehavior.OutlineHeaders;

            // Set fond bold for standard column headers
            GridStyleInfo gsiHeader = gridModel.BaseStylesMap["Header"].StyleInfo;
            gsiHeader.Font.Bold = true;
            gsiHeader.Enabled = true;

			this.gridDataBoundGrid1.VerticalThumbTrack = true;

			int lastRow = this.gridDataBoundGrid1.ViewLayout.LastVisibleRow;

			gridModel.ColWidths.ResizeToFit(GridRangeInfo.Cells(2, 0, gridModel.ColCount, lastRow), GridResizeToFitOptions.IncludeHeaders|GridResizeToFitOptions.NoShrinkSize|GridResizeToFitOptions.ResizeCoveredCells);
			this.gridDataBoundGrid1.AllowResizeToFit = false;
            this.gridDataBoundGrid1.Model.Cols.Hidden[0] = true;
            this.gridDataBoundGrid1.EnableAddNew = false;

			// Grid will repaint ittself later.
            this.gridDataBoundGrid1.EndUpdate();
		
			this.gridDataBoundGrid1.DefaultRowHeight = 18;
			this.gridDataBoundGrid1.DefaultColWidth = 70;			
            
		}

		private void expandAllbutton_Click(object sender, System.EventArgs e)
		{
			this.gridDataBoundGrid1.ExpandAll();
		}

		private void collapseAllButton_Click(object sender, System.EventArgs e)
		{
			this.gridDataBoundGrid1.CollapseAll();
		}

		private void okButton_Click(object sender, System.EventArgs e)
		{
			Close();
		}


	}
}
